﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO.Ports;

namespace SerialPortCom
{
    public partial class Form1 : Form
    {  SerialPort sp2 = null;//声明一个串口类 for get corrodination
        
        bool isOpen = false;//打开串口标志位

        public Form1()
        {
            InitializeComponent();
        }
        private void Form1_Load(object sender, EventArgs e)
        {
            this.MaximumSize = this.Size;
            this.MinimumSize = this.Size;
            this.MaximizeBox = false;

            CheckCOM();
            OpenCOM();
        }
        private void CheckCOM()
        {
            string tempstr2;
            try
            {
                tempstr2 = "COM1";
                sp2 = new SerialPort(tempstr2);
                sp2.Open();
                sp2.Close();
            }
            catch (Exception)
            {
                MessageBox.Show("没有检测到串口");
            }
        }

        private void OpenCOM()
        {

            sp2 = new SerialPort("COM1", 9600, Parity.None, 8, StopBits.One);
            sp2.ReadTimeout = -1;//设置超时读取时间
            sp2.RtsEnable = true;
            
            try//打开串口
            {
                sp2.Open();
                isOpen = true;
            }
            catch (Exception)
            {
                MessageBox.Show("串口无效或已被占用！", "错误提示");
            }
        }

        private void GetAbsoluteAddress()
        {

            //轴1：81h 01h 2Dh
            //轴2：82h 02h 2Ch
            //轴3：83h 03h 2Bh
            byte[] Hex8105 = new byte[2];
            byte[] Hex8004 = new byte[] { 0x80, 0x04 };
            byte[] Hex06 = new byte[] { 0x06 };
            byte[] HexAxisAsking = new byte[4]; //send asking commond
            byte[] Hex15 = new byte[] { 0x15 };
            List<byte> Data8104 = new List<byte>(2);//创建接收字节数组2组 
            byte[] Data06 = new byte[1]; //创建接收字节数组 06H
            List<byte> Data8005 = new List<byte>(2);//创建接收字节数组2组 
            List<byte> Data15 = new List<byte>(15);//创建接收字节数组15组 
            byte[] CheksumData = new byte[1];  //CheksumData[0]校验和==0为OK
            sp2.WriteTimeout = 2000;
            sp2.ReadTimeout = 2000;

            HexAxisAsking[0] = 0x00;
            HexAxisAsking[2] = 0xD2;   //编码器
            if (XAxis.Checked)  //轴1：81h 
            {
                Hex8105[0] = 0x81;
                HexAxisAsking[1] = 0x01;
                HexAxisAsking[3] = 0x2D;
            }
            else if (YAxisGrating.Checked)  //轴2：82h
            {
                Hex8105[0] = 0x82;
                HexAxisAsking[1] = 0x02;
                HexAxisAsking[2] = 0xC2;  //光栅尺
                HexAxisAsking[3] = 0x3C;  //光栅尺
            }
            else                       //轴3：83h
            {
                Hex8105[0] = 0x83;
                HexAxisAsking[1] = 0x03;
                HexAxisAsking[3] = 0x2B;
            }
            Hex8105[1] = 0x05;

            try
            {
            Lable1:
                // SEND 81H 05H
                sp2.DiscardInBuffer(); //丢弃接收缓冲区数据
                sp2.DiscardOutBuffer(); //丢弃发送缓冲区数据
                sp2.Write(Hex8105, 0, 2);
                System.Threading.Thread.Sleep(100);//延时100ms 等待接收完数据
                txtSendData.Text += Hex8105[0].ToString("X2") + Hex8105[1].ToString("X2") + "\r\n";

                // RECIEVED 81H 04H
                while (true)
                {
                    byte[] readBuffer = new byte[sp2.ReadBufferSize];
                    int count = sp2.Read(readBuffer, 0, sp2.ReadBufferSize);
                    for (int i = 0; i < count; i++)
                    {
                        Data8104.Add(readBuffer[i]);
                    }
                    if (sp2.BytesToRead == 0)
                        break;
                }
                //          sp2.Read(Data8104, 0, 2); //读取所接收到的数据
                txtReadData.Text += Data8104[0].ToString("X2") + Data8104[1].ToString("X2") + "\r\n";  //Data8104[1]位获得的数据（0X14）的整形值（20）
                sp2.DiscardInBuffer(); //丢弃接收缓冲区数据
                if (((Data8104[0] == Hex8105[0]) && (Data8104[1] == 0x04)) != true)  //
                {
                    MessageBox.Show("发送数据81h04h时发生错误！", "错误提示");
                    goto Lable1;  //重新发送命令
                }

                // SEND ADDRESS ASKING COMMOND
                sp2.Write(HexAxisAsking, 0, 4);
                System.Threading.Thread.Sleep(100);//延时100ms 等待接收完数据
                txtSendData.Text += HexAxisAsking[0].ToString("X2") + HexAxisAsking[1].ToString("X2")
                                    + HexAxisAsking[2].ToString("X2") + HexAxisAsking[3].ToString("X2") + "\r\n";
                // RECIVED 06H

                sp2.Read(Data06, 0, 1); //读取所接收到的数据
                sp2.DiscardInBuffer(); //丢弃接收缓冲区数据
                txtReadData.Text += Data06[0].ToString("X2") + "\r\n";  //Data06[0]位获得的数据（0X14）的整形值（20）
                if (Data06[0] != 0x06)
                {
                    MessageBox.Show("发送数据06h时发生错误！", "错误提示");
                    goto Lable1;  //重新发送命令
                }
                System.Threading.Thread.Sleep(100);//延时100ms 等待接收完数据

                Lable2:
                // RECIVED 80H 05H            
                while (true)
                {
                    byte[] readBuffer = new byte[sp2.ReadBufferSize];
                    int count = sp2.Read(readBuffer, 0, sp2.ReadBufferSize);
                    for (int i = 0; i < count; i++)
                    {
                        Data8005.Add(readBuffer[i]);
                    }
                    if (sp2.BytesToRead == 0)
                        break;
                }
                //          sp2.Read(Data8005, 0, 2); //读取所接收到的数据
                sp2.DiscardInBuffer(); //丢弃接收缓冲区数据
                txtReadData.Text += Data8005[0].ToString("X2") + Data8005[1].ToString("X2") + "\r\n";  //Data
                if (((Data8005[0] == 0x80) && (Data8005[1] == 0x05)) != true)
                {
                    MessageBox.Show("发送数据80h05h时发生错误！", "错误提示");
                    goto Lable1;  //重新发送命令
                }

                // SEND 80H 04H
                sp2.Write(Hex8004, 0, 2);
                System.Threading.Thread.Sleep(100);//延时10s 等待接收完数据， 时间太短则无法接受完数据，可以采用缓存机制
                txtSendData.Text += Hex8004[0].ToString("X2") + Hex8004[1].ToString("X2") + "\r\n";

                //RECIEVED ADDDRESS DATA

                while (true)
                {
                    byte[] readBuffer = new byte[sp2.ReadBufferSize];
                    int count = sp2.Read(readBuffer, 0, sp2.ReadBufferSize);
                    for (int i = 0; i < count; i++)
                    {
                        Data15.Add(readBuffer[i]);
                    }
                    if (sp2.BytesToRead == 0)
                        break;
                }
                string strdata = "";
                //         sp2.Read(Data15, 0, 15); //读取所接收到的数据  0B 01 D2 03 11 00 00 D8 FF 01 00 00 00 00 36 
                sp2.DiscardInBuffer(); //丢弃接收缓冲区数据
                for (int i = 0; i < 15; i++)
                {
                    strdata += Data15[i].ToString("X2");
                    CheksumData[0] += Data15[i];      //checksum 
                }
                txtReadData.Text += strdata + "\r\n";  //display data
                txtReadData.Text += "校验和：" + CheksumData[0].ToString() + "\r\n";  //display data
                if (((Data15[13] == 0x00) && (CheksumData[0] == 0x00)) != true) // Data15[15]校验和==0为OK error code and checksum is 0 is OK
                {
                    MessageBox.Show("发送数据地址数据时发生错误！", "错误提示");
                    // SEND 15H
                    sp2.Write(Hex15, 0, 1);
                    sp2.DiscardOutBuffer(); //丢弃写入缓冲区数据
                    System.Threading.Thread.Sleep(100);//延时10s 等待接收完数据， 时间太短则无法接受完数据，可以采用缓存机制
                    txtSendData.Text += Hex15[0].ToString("X2") + "\r\n";
                    goto Lable2;  //重新发送命令
                }

                // SEND 06H AND CLOSE
                sp2.Write(Hex06, 0, 1);
                System.Threading.Thread.Sleep(100);//延时100ms 等待接收完数据
                txtSendData.Text += Hex06[0].ToString("X2") + "\r\n";
                sp2.Close();

                //GET CORODINATION VALUE
                double address1, address2, GratingAddress;   //address1 多圈； 2单圈
                double actaddress;
                if (YAxisGrating.Checked)  //轴2：82h
                {
                    GratingAddress = Data15[12] * Math.Pow(2, 40) + Data15[11] * Math.Pow(2, 32) + Data15[10] * Math.Pow(2, 24) + Data15[9] * Math.Pow(2, 16) + Data15[8] * Math.Pow(2, 8) + Data15[7];                      //grating 2轴
                    if (GratingAddress >= Math.Pow(2, 47))
                    {
                        GratingAddress += -Math.Pow(2, 48);
                    }
                    actaddress = GratingAddress * 0.001;    //1um
                }
                else
                {
                    address1 = Data15[11] * 16 * 16 + Data15[10];  //多圈数据
                    address2 = Data15[9] * Math.Pow(2, 16) + Data15[8] * 16 * 16 + Data15[7];  //单圈数据
                    if (address1 >= 32768)
                    {
                        address1 += -65535;
                    }
                    if (address1 >= 0)
                    {
                        actaddress = address1 * 3 + 3 * address2 / 131071;
                    }
                    else
                    {
                        actaddress = address1 * 3 - 3 * address2 / 131071;
                    }
                }
                txtReadData.Text += "当前坐标值为（导程3mm）：" + actaddress + "mm" + "\r\n";  //display data
            }

            catch (Exception ex)
            {
                //MessageBox.Show(, "错误提示", MessageBoxButtons.OK, MessageBoxIcon.Information);  
                MessageBox.Show(ex.Message.ToString() + "请检查指令流！");
            }
        }

        private void btSendData_Click(object sender, EventArgs e)
        {
            GetAbsoluteAddress();
        }
 

    }
}
